function VentanaMensaje(int iX, int iY, int iAncho, int iAlto, int iAnchoMarco, 
						string pointer pTexto, byte bLineas, string sTitulo)
//Dibuja una ventana centrada en la pantalla mostrando el texto dado y esperando a que se pulse "OK".
//iX, coordenada X, si cero, centrado.
//iY, coordenada Y, si cero, centrado.
//iAncho. Ancho de la ventana. Si cero, de acuerdo con el texto.
//iAlto. Alto de la ventana. Si cero, de acuerdo con el texto.
//pTexto. Puentro al array de cadenas de texto.
//bLineas. Nmero de lneas que contiene pTexto.


private
	boton iIdeBotonOK;
	MarcoVentana iIdeMarcoVentana;
	string sBoton[0]="OK";
	int iIdeTexto[50];
	int iTextLength;
	int iTextLengthTemp;
	byte bContador;
end

begin
	iTextZ=iTextZ-500;
	iDrawingZZ=iDrawingZZ-400;
	Drawing_z(iDrawingZZ);
	Text_z=iTextZ;
	signal(ALL_PROCESS,s_freeze);
	frame;
	if (iAnchoMarco==0)
		iAnchoMarco=4;
	end
	bContador=0;
	iTextLength=0;
	while (bContador<=bLineas)
		iTextLengthTemp=Text_Width(0,pTexto[bContador]);
		if (iTextLengthTemp>iTextLength)
			iTextLength=iTextLengthTemp;
		end
		bContador++;
	end
	if(iTextLength>270-iAnchoMarco*2)
		iTextLength=270-iAnchoMarco*2;
	end
	if (iX==0)
		iX=(320-iTextLength)/2-20;
	end
	if (iY==0)
		iY=(120-(20+(bLineas+2)*10/2));
	end
	if (iAncho==0)
		iAncho=iTextLength+20;
	end
	if (iAlto==0)
		iAlto=20+(bLineas+2)*10+20;
	end

	iIdeMarcoVentana=MarcoVentana(iX, iY, iAncho, iAlto, iAnchoMarco,sTitulo);
	frame;
	iIdeBotonOK=boton(iAncho-2,20-2,&sBoton,1,0,4,rgb(212,208,200),0,7,0, iDrawingZZ-25, iTextZ-25);
	iIdeBotonOK.iX=iX+2;
	iIdeBotonOK.iY=iY+2+iAlto-20;
	iIdeBotonOK.bRepintar=1;
	bContador=0;
	while (bContador<bLineas)
		iIdeTexto[bContador]=write(0,iX+iAncho/2,iY+((iAlto-bLineas*9)/2-5)+(bContador*10),4,pTexto[bContador]);
		bContador++;
	end
	frame;
	while (!iIdeBotonOK.bPulsado)
		frame;
	end;
	while (iIdeBotonOK.bPulsado)
		frame;
	end;
	bContador=0;
	while (bContador<bLineas)
		Delete_Text(iIdeTexto[bContador]);
		bContador++;
	end
	if (exists(iIdeMarcoVentana))
		signal(iIdeMarcoVentana,s_kill_tree);
	end
	if (exists(iIdeBotonOk))
		signal(iIdeBotonOk,s_Kill_tree);
	end
	frame;
	signal(ALL_PROCESS,s_wakeup);
	frame;
end
//------------------------------------------------------------------------------
process MarcoVentana(int iX, int iY, int iAncho, int iAlto, int iAnchoMarco, string sTitulo)
// Dibuja el marco de una ventana.
private
	int iIde[70]=0;  // Array de identificadores de los objetos que usamos para dibujar el botn.
	int iIdeSombra=0;
	int iIdeSombra2=0;
	int bContador=0;
	dword dColor=0;
end

begin
	if (dColor==0)
		dColor=rgb(190,190,190);
	end

	Text_z=iTextZ-50;
	drawing_z(iDrawingZZ);
	drawing_color(rgb(100,100,100));
	iIdeSombra=draw_box(iX+5,iY+5,iX+iAncho-1+10,iY+iAlto-1+10);

	drawing_z(iDrawingZZ-20);
	if (sTitulo!="")
		drawing_color(rgb(0,0,200));
		iIde[14]=draw_box(iX+1,iY+1,iX+iAncho-2,iY+10);
		set_text_color(rgb(255,255,255));
		iIde[15]=write(0,iX+5,iY+1,0,sTitulo);
		set_text_color(rgb(0,0,0));
	end
	drawing_color(rgb(250,250,250));
	iIde[0]=draw_line(iX,iY+iAlto,iX+iAncho,iY+iAlto);
	iIde[1]=draw_line(iX+iAncho,iY,iX+iAncho,iY+iAlto);
	drawing_color(rgb(0,0,0));
	iIde[2]=draw_line(iX,iY,iX+iAncho,iY);
	iIde[3]=draw_line(iX,iY,iX,iY+iAlto);
	drawing_color(rgb(100,100,100));
	iIde[4]=draw_line(iX,iY+1,iX+iAncho,iY+1);
	iIde[5]=draw_line(iX+1,iY,iX+1,iY+iAlto);
	drawing_color(rgb(220,220,220));
	iIde[6]=draw_box(iX+1,iY+1,iX+iAncho-1,iY+iAlto-1);
	
	
	iX=iX-iAnchoMarco;
	iY=iY-iAnchoMarco;
	iAncho=iAncho+iAnchoMarco*2;
	iAlto=iAlto+iAnchoMarco*2;
	
	drawing_color(rgb(0,0,0));
	iIde[7]=draw_line(iX,iY+iAlto,iX+iAncho,iY+iAlto);
	iIde[8]=draw_line(iX+iAncho,iY,iX+iAncho,iY+iAlto);
	drawing_color(rgb(255,255,255));
	iIde[9]=draw_line(iX,iY,iX+iAncho,iY);
	iIde[10]=draw_line(iX,iY,iX,iY+iAlto);
	drawing_color(rgb(100,100,100));
	iIde[11]=draw_line(iX,iY+iAlto-1,iX+iAncho,iY+iAlto-1);
	iIde[12]=draw_line(iX+iAncho-1,iY,iX+iAncho-1,iY+iAlto);
	drawing_color(dColor);
	iIde[13]=draw_box(iX+1,iY+1,iX+iAncho-2,iY+iAlto-2);

	
	repeat
		frame;
	until (key(_space))

	
OnExit
	bContador=0;
	while (bContador<=13)
		delete_draw(iIde[bContador]);
		bContador++;
	end
		delete_draw(iIdeSombra);
		if (sTitulo!="")
			delete_draw(iIde[14]);
			delete_text(iIde[15]);
		end
	frame;

end
