//--------------------------------------------------------------------------------------
function byte EsFicheroDe(string sFichero);
// Funcin que intenta adivinar si un fichero es de texto plano o no.
// Variables:
// sFichero: Nombre del fichero a comprobar.
// Devuelte 0 no es de texto. 1 es de texto sin retorno de carro. 2 es de texto con retorno de carro
private
	int contador=0;
	byte caracteres=0;
	byte SaltoDeLinea10=0;
	byte SaltoDeLinea13=0;
	byte Tab=0;
	byte Otros=0;
	byte caracter=0;
	int iIdeFichero; // Ide del fichero abierto.
	byte bTFichero=2;
end

begin
	bTFichero=0;
	iIdeFichero=fopen(sFichero,O_READ);
	fseek(iIdeFichero,0,0);
	while ((contador<250)and(!feof(iIdeFichero)))
				fread(iIdeFichero,caracter);
				if ((caracter>31) and (caracter<255))
					caracteres++;
				else
					if (caracter==13)
						SaltoDeLinea13++;
					else
						if (caracter==10)
							SaltoDeLinea10++;
						else
							if (caracter==9)
								Tab++;
							else
								Otros++;
							end
						end
					end
				end
		contador++;
	end
	if (SaltoDeLinea13>0)
		bTFichero=2;
	else
		bTFichero=1;
	end
	if (Otros>0)
		bTFichero=0;
	end
	fseek(iIdeFichero,0,0);
	fclose(iIdeFichero);
	return bTFichero;
end
//--------------------------------------------------------------------------------------
function TransformaFicheroEnTexto(string sFichero);
// Funcin que transforma un fichero en texto plano.
// Variables:
// sFichero: Nombre del fichero a transformar.
// Devuelte un fichero formateado llamado: "temporal.tmp".

private
	int iTamanoFichero=0;
	int iContador=0;
	byte bCaracter=0;
	int iIdeFichero=0;
	int iIdeFicheroNew=0;
	VentanaProgreso Progreso=0;
//	dword dCien=100;
	dword dAntiguoValorOrigen=0;
end


begin
	dValorOrigen=1;
	Progreso=VentanaProgreso(0,0,0,0,0,iDrawingZZ,iTextZ);
	Progreso.bRepintar=1;
	frame;
	bAbortar=0;
	iTamanoFichero=pDirectorio[(Puntero+primerArchivo)].size;

	iIdeFichero=fopen(sFichero,o_read);
	rm("temporal.tmp"); // Borro el fichero este, exista o no.
	iIdeFicheroNew=fopen("temporal.tmp",o_write); //Fichero temporal
	
	iContador=0;
	while(iContador<iTamanoFichero and bAbortar==0)
		dValorOrigen=(((iContador)*100)/(iTamanoFichero));
		fread(iIdeFichero,bCaracter);
		if ((bCaracter<=32)or(bCaracter>=255))
			bCaracter=46; //46 = "."
		end
		fwrite(iIdeFicheroNew,bCaracter);
		iContador++;
		if(dAntiguoValorOrigen!=dValorOrigen)
			dAntiguoValorOrigen=dValorOrigen;
			frame;
		end
	end
	dValorOrigen=99;
	frame;
	fclose(iIdeFichero);
	fclose(iIdeFicheroNew);
	if (exists(Progreso))
		signal(Progreso,s_Kill_tree);
	end
	frame;
	return ;
end
//--------------------------------------------------------------------------------------
process VentanaProgreso(int iX, int iY, int iAncho, int iAlto, int iAnchoMarco, int iDrawingZ, int iTextZ)
// Muestra una ventana con dos barras con un progreso.
//iX, coordenada X, si cero, centrado.
//iY, coordenada Y, si cero, centrado.
//iAncho. Ancho de la ventana. Si cero, de acuerdo con el texto.
//iAlto. Alto de la ventana. Si cero, de acuerdo con el texto.

//Varibles de uso global:
// dword dValorOrigen;			// Valor a mostrar en la barra Origen de 0 a 100.
// byte bAbortar=0;				// Si 1 se aborta el proceso de copia.

private
	string sVentanaMensaje[0]="";
	boton iIdeBotonCancelar;
	MarcoVentana iIdeMarcoVentana;
	string sBotonCancelar[0]="Cancel";
	int bLineas=4;

	byte bContador;
	byte bSiNo=0;
	
	dword dValorOrigenAntiguo=0;
	dword dValorDestinoAntiguo=0;
end

begin
	iTextZ=iTextZ-200;
	iDrawingZZ=iDrawingZZ-200;
	while (!bRepintar)
		frame;
	end
	bRepintar=0;
	
	frame;
	if (iAnchoMarco==0)
		iAnchoMarco=4;
	end
	if (iX==0)
		iX=iAnchoMarco;
	end
	if (iAncho==0)
		iAncho=320-iAnchoMarco*2;
	end
	if (iAlto==0)
		iAlto=20+(bLineas+2)*15;
	end
	if (iY==0)
		iY=(240-iAnchoMarco*2-iAlto)/2;
	end

	iIdeMarcoVentana=MarcoVentana(iX, iY, iAncho, iAlto, iAnchoMarco, "Processing...");
	frame;
	iIdeBotonCancelar=boton((iAncho-2),20-2,&sBotonCancelar,1,0,4,rgb(212,208,200),0,7,0, iDrawingZZ-25, iTextZ-25);
	iIdeBotonCancelar.iX=iX+2;
	iIdeBotonCancelar.iY=iY+2+iAlto-20;
	iIdeBotonCancelar.bRepintar=1;
	iBarraOrigen=Barra(iX+iAnchoMarco+2,iAncho-iAnchoMarco*2-4,iY+iAnchoMarco+42,20,iDrawingZZ-25, iTextZ);
	iBarraOrigen.bRepintar=1;
	frame;

	while (!bAbortar)
		if (iIdeBotonCancelar.bPulsado)
			while (iIdeBotonCancelar.bPulsado)
				frame;
			end;
			sVentanaMensaje[0]="Abort, are you sure?";
			bSiNo=VentanaSiNo(0,0,0,0,0,&sVentanaMensaje,1,"");
			if (bSiNo)
				bAbortar=1;
			end
		end
		
		if (dValorOrigenAntiguo!=dValorOrigen)
			dValorOrigenAntiguo=dValorOrigen;
			iBarraOrigen.iValor=dValorOrigen;
		end
		frame;
	end;
OnExit
	if (exists(iIdeMarcoVentana))
		signal(iIdeMarcoVentana,s_kill_tree);
	end
	if (exists(iIdeBotonCancelar))
		signal(iIdeBotonCancelar,s_Kill_tree);
	end
	if (exists(iBarraOrigen))
		signal(iBarraOrigen,s_Kill_tree);
	end
	iTextZ=iTextZ+200;
	iDrawingZZ=iDrawingZZ+200;

	frame;
	return;
end
//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------
